note
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	RL_JSON_STRUCTURE
inherit
	RL_JSON_NODE[HASH_TABLE[RL_JSON_NODE[ANY],STRING_32]]
		rename
			make as kd_json_node_make
		redefine
			tail_descendent,
			put_tail,
			default_create
		end
create
	default_create
feature
	default_create
		do
			create item.make (10)
		end

	string_value (a_key : READABLE_STRING_GENERAL) : detachable STRING_32
		local
			l_key : STRING_32
		do
			l_key := as_string_32(a_key)
			if attached {RL_JSON_STRING_32} item [l_key] as al_string_32 then
--				Result := al_string_32.item
			end
		end

	put_string(a_string : READABLE_STRING_GENERAL; a_key : separate READABLE_STRING_GENERAL)
		local
			l_string : RL_JSON_UTF8_STRING
			l_key : STRING_32
		do
			l_key := as_string_32(a_key)
			create l_string.make (as_string_32(a_string))
			item[l_key] := l_string
		end


feature {RL_JSON_NODE} --Implementation
	tail_descendent(a_key : ARRAY[ANY];a_start : INTEGER) : detachable RL_JSON_NODE[ANY]
		local
			l_string : STRING_32
		do
			if a_key.count >= a_start and then attached {READABLE_STRING_GENERAL} a_key[a_start] as al_key then
				l_string := as_string_32(al_key)
				if a_start = a_key.count then
					Result := item[l_string]
				elseif attached item[l_string] as al_next then
					Result := al_next.tail_descendent(a_key,a_start + 1)
				end
			end
		end
	put_tail(a_value : RL_JSON_NODE[ANY];a_path : ARRAY[ANY];a_start : INTEGER)
		local
			l_structure : RL_JSON_STRUCTURE
			l_key : STRING_32
		do
			if attached {STRING_GENERAL} a_path[a_start] as al_key then
				l_key := as_string_32(al_key)
				if a_path.count > a_start then
					if attached item[l_key] as al_item then
						al_item.put_tail(a_value,a_path,a_start + 1)
					elseif attached {STRING_GENERAL} a_path[a_start+1] then
						create l_structure
						item[l_key] := l_structure
						l_structure.put_tail(a_value,a_path,a_start + 1)
					end
				else
					item[l_key] := a_value
				end
			end
		end

end
